<?php

namespace Treewec\DataStructures;

/**
 * Test class for LIFO.
 * Generated by PHPUnit on 2012-07-03 at 16:08:13.
 * @group data_structures
 */
class LIFOTest extends \PHPUnit_Framework_TestCase {

    /** @var LIFO */
    private $structure;

    protected function setUp() {
        $this->structure = new LIFO();
        $this->structure->insertElement(1);
        $this->structure->insertElement(2);
        $this->structure->insertElement(3);
    }

    public function testClear() {
        $this->structure->clear();
        parent::assertEquals(0, $this->structure->size());
    }

    public function testIsEmpty() {
        parent::assertFalse($this->structure->isEmpty());
        $this->structure->clear();
        parent::assertTrue($this->structure->isEmpty());
    }

    public function testSize() {
        parent::assertEquals(3, $this->structure->size());
    }

    public function testInsertElement() {
        $this->structure->clear();
        $invalidValues = array('', null, false, array());
        foreach ($invalidValues as $value) {
            $this->structure->insertElement($value);
            parent::assertTrue($this->structure->isEmpty());
        }
        // valid = non empty value
        $validValues = array('0', 0, 'hello', new \Exception());
        foreach ($validValues as $value) {
            $this->structure->clear();
            $this->structure->insertElement($value);
            parent::assertFalse($this->structure->isEmpty());
        }
    }

    public function testRemoveElement() {
        parent::assertEquals(3, $this->structure->removeElement());
        parent::assertEquals(2, $this->structure->removeElement());
        parent::assertEquals(1, $this->structure->removeElement());
        // if empty structrue -> null
        parent::assertNull($this->structure->removeElement());
    }

}

?>
